#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include <time.h>
#include "main.h"

//This sample application, queues 2 devices. I've chosen two that I had connected, you can choos two that you
// might have connected, only one if that's all you have connected. As it is configured, it reads the device
// id's from DevCfg.ini which resides in the same folder as the executable. You can obviously configure the
// code however you want. 
//The code starts by initializing the DLL - this is required and must be done first. It then passes the device
// id's that we want initialized, to the DLL. It then just loops and polls the DLL to see when the devices have
// been iniitialized.

BOOLEAN LoadLibraries()
{ hLib30x = LoadLibrary ("LL_USB2k.dll"); if(!hLib30x) return FALSE; return TRUE; }

BOOLEAN InitLibFuncs()
{  
	EX_SetPolledModeChan = (P_DLL_EX_SET_CHAN)GetProcAddress(hLib30x, "EX_SetPolledModeChan"); if(!EX_SetPolledModeChan) return FALSE;
	EX_GetOneConversion = (P_DLL_EX_GET_ONE_CONVERSION)GetProcAddress(hLib30x, "EX_GetOneConversion"); if(!EX_GetOneConversion) return FALSE;
	EX_SendDigout = (P_DLL_EX_SEND_DIGOUT)GetProcAddress(hLib30x, "EX_SendDigout"); if(!EX_SendDigout) return FALSE;
	EX_GetDigin = (P_DLL_EX_GET_DIGIN)GetProcAddress(hLib30x, "EX_GetDigin"); if(!EX_GetDigin) return FALSE;

	//NEW ------------------------
	EX_DLL_Init = (P_EX_DLL_INIT)GetProcAddress(hLib30x, "EX_DLL_Init"); if(!EX_DLL_Init) return FALSE;
	EX_ThreadedInitDev = (P_EX_THREADED_INIT_DEV)GetProcAddress(hLib30x, "EX_ThreadedInitDev"); if(!EX_ThreadedInitDev) return FALSE;
	EX_EndThreadedDevInit = (P_EX_EndThreadedDevInit)GetProcAddress(hLib30x, "EX_EndThreadedDevInit"); if(!EX_EndThreadedDevInit) return FALSE;

	return TRUE;
} 
int __cdecl main()
{
	char szWinTitle[128]; sprintf(szWinTitle, " multi-dev init thread test");
	USHORT ausDevID[32]; memset(ausDevID, 0 , sizeof(ausDevID));
	DOUBLE dblDevRate[32]; memset(dblDevRate, 0 , sizeof(dblDevRate));
	BYTE bDevChan[32]; memset(bDevChan, 0 , sizeof(bDevChan));
	DOUBLE dblMillivolts;
	BYTE bIndex;
	char szIniStr[128]; char szIniStrTemp[128]; char szDoubleBuff[32];
	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		sprintf(szIniStr, "DEV_"); sprintf(szIniStrTemp, "%d", bIndex + 1); strcat(szIniStr, szIniStrTemp);
		ausDevID[bIndex] = (USHORT)GetPrivateProfileInt(szIniStr,"ID",0,".\\DevCfg.ini");
		if(!ausDevID[bIndex]) break;
		GetPrivateProfileString(szIniStr, "Rate", "", szDoubleBuff, sizeof(szDoubleBuff), ".\\DevCfg.ini");
		dblDevRate[bIndex] = atof(szDoubleBuff); if(!dblDevRate[bIndex]) dblDevRate[bIndex] = 100.0;
		bDevChan[bIndex] = (BYTE)GetPrivateProfileInt(szIniStr,"Chan",0,".\\DevCfg.ini");
		printf("got dev: %u, rate: %4.2lf, chan: %d\n", ausDevID[bIndex], dblDevRate[bIndex], bDevChan[bIndex]);
	}

	SetConsoleTitle(szWinTitle);
	

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs()) { printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	if(!EX_DLL_Init(FindWindow(NULL, szWinTitle)))
	{
		system("cls"); printf("failed EX_DLL_Init\n\n"); printf("any key to exit "); getch();
		return 0;
	} 


	UINT uiInitStat = 0;
	BOOLEAN fDevDone[32]; 


	while(true)
	{
		memset(fDevDone, 0, sizeof(fDevDone));
		BYTE bNumDevices = 0;

		//queue the devices
		for(bIndex = 0; bIndex < 32; bIndex++)
		{ 
			if(!ausDevID[bIndex]) break;
			if(ausDevID[bIndex]) EX_ThreadedInitDev(ausDevID[bIndex], dblDevRate[bIndex], bDevChan[bIndex], &uiInitStat, TRUE); 
			bNumDevices++; 
		}

		//check device init stat
		//clock_t clkWaitTime = clock() + 15000;
		BYTE bDevDone = 0;
		printf("\n\nwaiting for a dev", ausDevID[bIndex]);
		char cUserInputVal = NULL; 

		//while(clock() < clkWaitTime)
		while(true)
		{
			for(bIndex = 0; bIndex < bNumDevices; bIndex++)
			{
				if(fDevDone[bIndex]) continue;
				if(ausDevID[bIndex] == 0) continue;

				if(!EX_ThreadedInitDev(ausDevID[bIndex], dblDevRate[bIndex], bDevChan[bIndex], &uiInitStat, TRUE)) //if success, the device will also be dequeued
				{
					printf("failed init:  %X, dev: %u, index: %d\n\n", uiInitStat, ausDevID[bIndex], bIndex);
					printf("any key to continue "); getch();
					printf("\n\nwaiting for a dev", ausDevID[bIndex]);
					fDevDone[bIndex] = TRUE;
					continue;
				}
				if(uiInitStat) 
				{
					fDevDone[bIndex] = TRUE;
					if(!(uiInitStat & MDI_DONE_SUCCESS))
					{ 
						printf("\nfailed initializing %u, error: 0x%X\n", ausDevID[bIndex], uiInitStat); 
						printf("any key to continue: "); getch(); printf("\n");//2-27-09
						continue;
					}
					printf("\nsuccess initializing %u", ausDevID[bIndex]);
					if(!EX_GetOneConversion(ausDevID[bIndex], &dblMillivolts)) printf("\nfailed to get voltage\n"); 
					else(printf("\nvoltage: %2.6lf\n", dblMillivolts / 1000.0));

					printf("\n\nwaiting for a dev", ausDevID[bIndex]);
					continue;
				}
				printf(" .");
				Sleep(1000);
			}

			
			//if not all dev done (either success or failure) continue trying
			//for(bIndex = 0; bIndex < bNumDevices; bIndex++)
			//{ if(!fDevDone[bIndex]) continue; }
			BOOLEAN fContinueDevInit = FALSE;
			for(bIndex = 0; bIndex < bNumDevices; bIndex++)
			{ if(fDevDone[bIndex] == 0) fContinueDevInit = TRUE; } if(fContinueDevInit) continue;


			printf("\ndev: %u, index: %u numdevices: %u - breaking\n", ausDevID[bIndex], bIndex, bNumDevices); 
			printf("\nfDevDone_0: %u, fDevDone_1: %u\n", fDevDone[0], fDevDone[1]); 
			printf("any other key to continue: "); getch();
			

			break; 
		}

		printf("\nending dev init thread"); 
		EX_EndThreadedDevInit();
		printf("\ndone ending dev init thread"); 

		printf("\npress  'R'  to  Reinitialize all devices\n"); 
		printf("any other key to exit now: "); 
		cUserInputVal = (char)getch();
		if((cUserInputVal == 'R') || (cUserInputVal == 'r') )
		{
			system("cls"); 
			printf("\nreiniitializing -"); 
			continue;
		}

		system("cls"); 
		printf("Exiting DLL - please wait . . .\n\n");
		EX_EndThreadedDevInit();
		return 0;

	}

	EX_EndThreadedDevInit();
	printf("done loop\n\n");
	printf("any key to exit "); 
	getch();
	return 0;
}





